var _gridDatasetMenu1=null;	//fot table: editable
var _gridDatasetMenu2=null;	//for view, query: readonly

function boxGridInit() {
	_gridDatasetMenu1=document.createElement('DIV');
	_gridDatasetMenu1.style.fontSize='8pt';
	_gridDatasetMenu1.innerHTML='Offset: <input type=text size=4 id="offset" onkeydown="numberSeqByKey(event)" onkeyup="fieldNum(this)" style="text-align:right"> Limit: <input type=text size=4 id="limit" onkeydown="numberSeqByKey(event)" onkeyup="fieldNum(this)" style="text-align:right"> <a onclick="boxTabMenuAction(this, \'grid\', \'get\')">Get</a> | <a onclick="boxTabMenuAction(this, \'grid\', \'prev\')">◀</a> <a onclick="boxTabMenuAction(this, \'grid\', \'next\')">▶</a> | <a onclick="boxTabMenuAction(this, \'grid\', \'insert\')">Insert data</a> | <a onclick="boxTabMenuAction(this, \'grid\', \'delete\')">Delete data</a>';

	_gridDatasetMenu2=document.createElement('DIV');
	_gridDatasetMenu2.style.fontSize='8pt';
	_gridDatasetMenu2.innerHTML='Offset: <input type=text size=4 id="offset" onkeydown="numberSeqByKey(event)" onkeyup="fieldNum(this)" style="text-align:right"> Limit: <input type=text size=4 id="limit" onkeydown="numberSeqByKey(event)" onkeyup="fieldNum(this)" style="text-align:right"> <a onclick="boxTabMenuAction(this, \'grid\', \'get\')">Get</a> | <a onclick="boxTabMenuAction(this, \'grid\', \'prev\')">◀</a> <a onclick="boxTabMenuAction(this, \'grid\', \'next\')">▶</a>';
}

function boxGridDataset(grid, mdi) {
	this.grid=grid;
	this.mdi=mdi;

	this.init=false;

	this.menu=null;
	this.menuDiv={};

	this.editable=false;

	this.offset=0;
	this.limit=50;
	this.order='';
	this.orderDirection='ASC';

	this.dbExec=function() {
		if (!this.init) this._init();
		if (mdi.type == 'table')
			sql='SELECT rowid, * FROM '+mdi.data.name+(this.order?' ORDER BY '+this.order+' '+this.orderDirection:'')+' LIMIT '+this.limit+' OFFSET '+this.offset;
		else
			sql='SELECT * FROM '+mdi.data.name+(this.order?' ORDER BY '+this.order+' '+this.orderDirection:'')+' LIMIT '+this.limit+' OFFSET '+this.offset;
		boxDbExec(this.mdi, sql);
		this.syncMenu();
	};

	this.dbResponse=function(dbRes) {
		var div=this.mdi.tab['Data'];
		if (!div) return;

		while (div.childNodes.length > 0)
			div.removeChild(div.childNodes[0]);

		if (dbRes.columns && dbRes.columns[0] && dbRes.columns[0].columnname)
			this.grid.header=dbRes.columns[0].columnname;

		div.appendChild(this.grid.draw());

		if (dbRes.row) {
			for (var i=0; i < dbRes.row.length; i++)
				this.grid.appendData(dbRes.row[i].data);
		}
	};

	this.orderChange=function(order) {
		if (this.order == order) {
			if (this.orderDirection == 'ASC')
				this.orderDirection='DESC';
			else
				this.orderDirection='ASC';
		}else{
			this.order=order;
			this.orderDirection='ASC';
		}
		this.dbExec();
	};

	this.syncMenu=function() {
		this.menuDiv['offset'].value=this.offset;
		this.menuDiv['limit'].value=this.limit;
	};

	this.switchAction=function(action) {
		switch (action) {
			case 'get':
				this.limit=number(this.menuDiv['limit'].value);
				this.offset=number(this.menuDiv['offset'].value);
				if (this.limit <= 0) this.limit=50;
				if (this.offset < 0) this.offset=0;
				this.dbExec();
			break;
			case 'prev':
				var offset=number(this.menuDiv['offset'].value);
				var limit=number(this.menuDiv['limit'].value);
				offset-=limit;
				this.menuDiv['offset'].value=offset.toString();
				this.switchAction('get');
			break;
			case 'next':
				var offset=number(this.menuDiv['offset'].value);
				var limit=number(this.menuDiv['limit'].value);
				offset+=limit;
				this.menuDiv['offset'].value=offset.toString();
				this.switchAction('get');
			break;
			case 'insert':
				inspectorTableNewData(this.mdi.data);
			break;
			case 'delete':
				var input=oFindChildByTagNames(this.grid.table, 'INPUT');
				var checkbox=[];
				for (var i=input.length; i--;){
					if (input[i].type == 'checkbox' && input[i].checked == true) {
						checkbox.push(input[i].value);
					}
				}
				if (checkbox && checkbox.length > 0) {
					if (confirm('Delete '+checkbox.length+' data?'))
						boxDbExec(grid.dataset.mdi, 'DELETE FROM "'+this.mdi.data.name+'" WHERE rowid in ('+(checkbox.join(','))+')', 'delete');
				}else
					alert('Select data to delete.');
			break;
		}
	};

	this._init=function() {
		if (mdi.type == 'table') {
			this.editable=true;
			this.menu=_gridDatasetMenu1.cloneNode(true);
		}else
			this.menu=_gridDatasetMenu2.cloneNode(true);
		this.menuDiv['offset']=oFindChild(this.menu, 'INPUT', 'offset');
		this.menuDiv['limit']=oFindChild(this.menu, 'INPUT', 'limit');
		this.init=true;
	};
}

function boxGrid() {
	this.width='';
	this.header=[];
	this.align=[];
	this.type=[];

	this.table=null;

	this.dataset=null;

	this.draw=function() {
		this.table=document.createElement('TABLE');
		this.table.className='grid';
		this.table.cellSpacing=1;
		this.table.border=0;
		this.table.grid=this;
		if (this.width)
			this.table.style.width=this.width;
		var row=this.table.insertRow(0);
		for (var i=0; i < this.header.length; i++) {
			var cell=row.insertCell(row.cells.length);
			cell.className='header';
			if (this.dataset) {
				if (this.dataset.order == this.header[i]) {
					innerText(cell, this.header[i]+(this.dataset.orderDirection=='DESC'?'▼':'▲'));
					cell.style.textDecoration='underline';
				}else
					innerText(cell, this.header[i]);
				cell.title='Order by this column';
				cell.style.cursor='s-resize';
				addEvent(cell, 'click', boxGridDatasetOrderChange);
			}else
				innerText(cell, this.header[i]);
		}
		return this.table;
	};

	this.clearData=function(rownum) {
		if (!rownum || rownum < 1) {
			while (this.table.rows.length > 1)
				this.table.deleteRow(1);
		}else
			this.table.deleteRow(rownum);
	}

	this.clear=function() {
		while (this.table.rows.length > 0)
			this.table.deleteRow(0);
	}

	this.appendData=function() {
		var row=this.table.insertRow(this.table.rows.length);
		if (isArray(arguments[0])) data=arguments[0];
		else data=arguments;
		if (this.dataset && this.dataset.editable)
			addEvent(row, 'dblclick', boxGridDatasetEdit);
		for (var i=0; i < data.length; i++) {
			var cell=row.insertCell(row.cells.length);
			if (this.align[i]) cell.style.textAlign=this.align[i];
			if (this.type[i] == 'html')
				cell.innerHTML=data[i];
			else
				innerText(cell, data[i]);
			if (i == 0 && this.dataset && this.dataset.editable)
				cell.innerHTML='<input type=checkbox value="'+data[i]+'" style="float:left">'+cell.innerHTML;
		}

		if (i < this.header.length) {
			for (; i < this.header.length; i++) {
				var cell=row.insertCell(row.cells.length);
				cell.innerHTML='&nbsp;';
			}
		}
	};

	this.setData=function(data, rownum) {
		if (!rownum) rownum=this.table.rows.length-1;
		this.table.rows[rownum].data=data;
	};

	this.setLink=function(action, cellnum, rownum) {
		if (!rownum) rownum=this.table.rows.length-1;
		if (!cellnum) cellnum=0;
		var cell=this.table.rows[rownum].cells[cellnum];
		if (!cell) return;
		cell.style.backgroundColor='#F6FCFF';
		cell.style.cursor='pointer';
		cell.onclick=new Function('boxTabMenuAction(this, "'+action+'")');
	};

	this.addTitle=function(html, rownum) {
		var row;
		if (typeof rownum == 'undefined' || rownum > this.table.rows.length || rownum < 0)
			row=this.table.insertRow(this.table.rows.length);
		else
			row=this.table.insertRow(rownum);
		var cell=row.insertCell(0);
		cell.className='title';
		cell.colSpan=this.header.length;
		cell.innerHTML=html;
	};

	this.initDataset=function(mdi) {
		if (!this.dataset) {
			this.dataset=new boxGridDataset(this, mdi);
			this.dataset.dbExec();
		}
		return this.dataset;
	};
}

function boxGridDatasetOrderChange(e) {
	if (_isIE && !e) e=window.event;
	if (!e) return;
	var eventSrc=(_isIE)?e.srcElement:e.target;
	var table=oFindParentByTagName(eventSrc, 'TABLE');
	if (!table) return;
	var grid=table.grid;
	if (!grid || !grid.dataset) return;
	grid.dataset.orderChange(innerText(eventSrc).replace(/[▼▲]$/, ''));
}

function boxGridDatasetEdit(e) {
	if (_isIE && !e) e=window.event;
	if (!e) return;
	var eventSrc=(_isIE)?e.srcElement:e.target;
	var table=oFindParentByTagName(eventSrc, 'TABLE');
	if (!table) return;
	var grid=table.grid;
	if (!grid || !grid.dataset) return;
	if (eventSrc.tagName != 'TD') return;
	if (eventSrc.cellIndex == 0) {
		alert('Cannot edit rowid.');
		return;
	}
	var curdata=innerText(eventSrc);
	var width=Math.max(50, eventSrc.clientWidth-8);
	eventSrc.innerHTML='null? <input type=checkbox onclick="boxGridDatasetEditNull(this)"><br>';
	var input=appendNew(eventSrc, 'TEXTAREA');
	addEvent(input, 'dblclick', boxGridDatasetEditEnd);
	input.curdata=curdata;
	input.style.width=width;
	input.value=curdata;
	try{input.focus();}catch(e){}
}

function boxGridDatasetEditNull(check) {
	if (!check) return;
	if (check.checked == true) {
		if (!confirm('Set to null?')) {
			check.checked=check.defaultChecked=false;
			return;
		}
		var table=oFindParentByTagName(check, 'TABLE');
		if (!table) return;
		var grid=table.grid;
		if (!grid || !grid.dataset) return;
		var cell=oFindParentByTagName(check, 'TD');
		var row=oFindParentByTagName(check, 'TR');
		if (!cell || !row) return;

		if (!grid.dataset.mdi || !grid.dataset.mdi.data) return;
		var header=table.rows[0];
		if (!header) return;
		var column=header.cells[cell.cellIndex];
		if (!column) return;
		var columnName=innerText(column);
		var rowid=innerText(row.cells[0]);
		boxDbExec(grid.dataset.mdi, 'UPDATE "'+grid.dataset.mdi.data.name+'" SET "'+(columnName.replace(/[▼▲]$/, ''))+'"=NULL WHERE rowid='+rowid, 'update');
		innerText(cell, '');
	}
}

function boxGridDatasetEditEnd(e) {
	if (_isIE && !e) e=window.event;
	if (!e) return;
	var eventSrc=(_isIE)?e.srcElement:e.target;
	var table=oFindParentByTagName(eventSrc, 'TABLE');
	if (!table) return;
	var grid=table.grid;
	if (!grid || !grid.dataset) return;
	if (eventSrc.tagName != 'TEXTAREA') return;
	var cell=oFindParentByTagName(eventSrc, 'TD');
	var row=oFindParentByTagName(eventSrc, 'TR');
	if (!cell || !row) return;
	if (eventSrc.curdata == eventSrc.value) {
		innerText(cell, eventSrc.value);
		return;
	}

	if (!grid.dataset.mdi || !grid.dataset.mdi.data) return;
	if (confirm('Edit commit?')) {
		var header=table.rows[0];
		if (!header) return;
		var column=header.cells[cell.cellIndex];
		if (!column) return;
		var columnName=innerText(column);
		var rowid=innerText(row.cells[0]);
		boxDbExec(grid.dataset.mdi, 'UPDATE "'+grid.dataset.mdi.data.name+'" SET "'+(columnName.replace(/[▼▲]$/, ''))+'"=\''+(eventSrc.value.replace(/\'/g, '\'\''))+'\' WHERE rowid='+rowid, 'update');
		innerText(cell, eventSrc.value);
	}else
		innerText(cell, eventSrc.curdata);
}
